package cn.ninegame.genericframework.module;

import android.content.Context;
import android.text.TextUtils;

import java.lang.reflect.Constructor;

import cn.ninegame.genericframework.tools.ReflectHelper;
import cn.ninegame.genericframework.basic.IController;
import cn.ninegame.genericframework.ui.BaseDialogFragment;
import cn.ninegame.genericframework.ui.BaseFragment;

/**
 * Created by lingcong on 2015/6/2.
 */
class ModuleEntryLocal extends AbsModuleEntry {

    @Override
    public IController loadController(String controllerID) {
        if (TextUtils.isEmpty(controllerID)) {
            return null;
        }
        getContext();

        IController controller = null;
        try {
            Class<?> clazz = Class.forName(controllerID);
            if(clazz == null) {
                return null;
            }

            Constructor<?> constructor = clazz.getDeclaredConstructor();
            Object obj = constructor.newInstance();
            if(obj instanceof IController) {
                controller = (IController) obj;
                controller.setModuleEntry(this);
            }

        } catch(Exception e) {
            e.printStackTrace();
        }

        return  controller;
    }

    @Override
    public Object loadControllerObject(String controllerID) {
        if (TextUtils.isEmpty(controllerID)) {
            return null;
        }
        getContext();

        Object controller = null;
        try {
            Class<?> clazz = Class.forName(controllerID);
            if(clazz == null) {
                return null;
            }

            Constructor<?> constructor = clazz.getDeclaredConstructor();
            controller = constructor.newInstance();


        } catch(Exception e) {
            e.printStackTrace();
        }

        return  controller;
    }


    @Override
    public BaseFragment loadFragment(String fragmentName) {
        BaseFragment fragment = (BaseFragment) ReflectHelper.loadClass(fragmentName);
        if (fragment != null) {
            fragment.setModuleEntry(this);
        }
        return fragment;
    }

    @Override
    public BaseDialogFragment loadDialogFragment(String fragmentName) {
        BaseDialogFragment dialogFragment = (BaseDialogFragment) ReflectHelper.loadClass(fragmentName);
        if (dialogFragment != null) {
            dialogFragment.setModuleEntry(this);
        }
        return dialogFragment;
    }


    @Override
    public Context getContext() {
        return mBaseContext;
    }

    @Override
    public int getModuleType() {
        return ModuleType.LOCAL;
    }

    @Override
    public boolean isNeverLoad() {
        return false;
    }

    @Override
    protected boolean loadModule() {
        return true;
    }

    @Override
    public boolean isNotLoad() {
        return false;
    }

    @Override
    public boolean isLoaded() {
        return true;
    }
}
