package cn.ninegame.genericframework.module;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;

import java.io.File;

import cn.ninegame.genericframework.config.ModulePathManager;

/**
 * ****************************************************************************
 * Copyright @ 2009 - 2015 www.9game.cn All Rights Reserved
 * <p/>
 * Creation    : 2016-01-13
 * Author      : lihq@ucweb.com
 * Description : Module信息
 * ****************************************************************************
 */
public class ModuleInfo {
    String id;
    String version;
    String signature = "";
    long buildTime;
    boolean isPlugin = false;
    boolean isAndroidLibrary = false;

    public boolean isAndroidLibrary() {
        return isAndroidLibrary;
    }

    public void setAndroidLibrary(boolean androidLibrary) {
        isAndroidLibrary = androidLibrary;
    }

    private File mSourceFile;
    private PackageInfo mPackageInfo;

    public boolean isPlugin() {
        return isPlugin;
    }

    public void setPlugin(boolean plugin) {
        isPlugin = plugin;
    }

    public String getID() {
        return id;
    }

    public void setID(String id) {
        this.id = id;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getSignature() {
        return signature;
    }

    public void setSignature(String signature) {
        this.signature = signature;
    }

    public long getBuildTime() {
        return buildTime;
    }

    public void setBuildTime(long buildTime) {
        this.buildTime = buildTime;
    }

    public File getSourceFile() {
        if (mSourceFile != null) {
            return mSourceFile;
        }
        return mSourceFile = ModulePathManager.getInstance().getModuleApk(id, version);
    }

    public PackageInfo getPackageInfo(Context context) {
        if (mPackageInfo != null) {
            return mPackageInfo;
        }

        try {
            mPackageInfo = context.getPackageManager().getPackageArchiveInfo(getSourceFile().getAbsolutePath(),
                    PackageManager.GET_META_DATA | PackageManager.GET_ACTIVITIES | PackageManager.GET_CONFIGURATIONS);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mPackageInfo;
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();

        sb.append(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>").append("\n")
                .append("name:").append(id).append("\n")
                .append("version:").append(version).append("\n")
                .append("signature:").append(signature).append("\n")
                .append("buildTime:").append(buildTime).append("\n")
                .append("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<").append("\n");
        return sb.toString();
    }
}
