package cn.ninegame.genericframework.tools;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;

/**
 * <p>Title: ucweb</p>
 * <p/>
 * <p>Description: </p>
 *  设备相关信息的工具类
 * <p>Copyright: Copyright (c) 2016</p>
 * <p/>
 * <p>Company: ucweb.com</p>
 *
 * @author ZhuZhiFan (zhifan.zzf@alibaba-inc.com)
 * @date 2016/6/2
 */
public class DeviceInfoUtil {

    /**
     * 计算某个时间段内AppCpuTime与TotalCpuTime的变化，然后按照比例换算成该进程的Cpu使用率
     *
     * Android系统本省也有一个类是用来显示Cpu使用率的：
     * android/system/frameworks/base/packages/SystemUI/src/com/android/systemui/LoadAverageService.java
     * @return
     */
    public static float getProcessCpuUsage() {

        float totalCpuTime1 = getTotalCpuTime();
        float processCpuTime1 = getAppCpuTime();
        try {
            Thread.sleep(360);

        } catch (Exception e) {
        }

        float totalCpuTime2 = getTotalCpuTime();
        float processCpuTime2 = getAppCpuTime();

        float cpuRate = (processCpuTime2 - processCpuTime1)
                / (totalCpuTime2 - totalCpuTime1);

        return cpuRate;
    }

    public static long getTotalCpuTime() { // 获取系统总CPU使用时间
        String[] cpuInfos = null;
        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(
                    new FileInputStream("/proc/stat")), 1000);
            String load = reader.readLine();
            reader.close();
            if (load != null) {
                cpuInfos = load.split(" ");
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        long totalCpu = 0;
        if (cpuInfos != null) {
            totalCpu = Long.parseLong(cpuInfos[2])
                    + Long.parseLong(cpuInfos[3]) + Long.parseLong(cpuInfos[4])
                    + Long.parseLong(cpuInfos[6]) + Long.parseLong(cpuInfos[5])
                    + Long.parseLong(cpuInfos[7]) + Long.parseLong(cpuInfos[8]);
        }
        return totalCpu;
    }

    public static long getAppCpuTime() { // 获取应用占用的CPU时间
        String[] cpuInfos = null;
        try {
            int pid = android.os.Process.myPid();
            BufferedReader reader = new BufferedReader(new InputStreamReader(
                    new FileInputStream("/proc/" + pid + "/stat")), 1000);
            String load = reader.readLine();
            reader.close();
            if (load != null) {
                cpuInfos = load.split(" ");
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        long appCpuTime = 0;
        if (cpuInfos != null) {
            appCpuTime = Long.parseLong(cpuInfos[13])
                    + Long.parseLong(cpuInfos[14]) + Long.parseLong(cpuInfos[15])
                    + Long.parseLong(cpuInfos[16]);
        }
        return appCpuTime;
    }
}
